<?xml version="1.0"?>
<xsl:stylesheet version="1.0" 
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:output indent="yes" method="html"/>
<!--
<xsl:strip-space elements="*"/>
-->

<xsl:template match="translation_unit">
<HTML>
	<HEAD>
	   <TITLE> files </TITLE>
	</HEAD>
	<BODY BGCOLOR="white">
	<H2> FILES </H2>

    <xsl:variable name="file" select="substring-before(@filename,'.')"/>
	<xsl:variable name="source_page" select="concat($file, '.html')"/>

	<xsl:for-each select="function_definition | declaration">
	   <xsl:variable name="pre-node" 
	            select="preceding-sibling::*[1]"/>
	   <xsl:if test="not(@filename=$pre-node/@filename)">

	      <A HREF="{$source_page}#{@filename}" TARGET="SOURCE">
		     <xsl:call-template name="simple_name"/>
		  </A><BR/>

	   </xsl:if>
	</xsl:for-each>   
    </BODY>
</HTML>
</xsl:template>


<xsl:template name="simple_name">
   <xsl:param name="long_name">
      <xsl:value-of select="@filename"/>
   </xsl:param>

   <xsl:if test="not(contains($long_name, '/'))">
      <xsl:value-of select="$long_name"/>
   </xsl:if>
   <xsl:if test="contains($long_name, '/')">
      <xsl:variable name="makeup_name" 
         select="substring-after($long_name,'/')"/>
      <xsl:call-template name="simple_name">
	     <xsl:with-param name="long_name">
		    <xsl:value-of select="$makeup_name"/>
         </xsl:with-param>
      </xsl:call-template>
   </xsl:if>	  
</xsl:template>

</xsl:stylesheet>