import org.w3c.dom.Node;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

class TreeInfo {
  Node newState_comp;
  NodeIdList identList;
  NodeIdList leftIdList;
}

class BackWardSlice {
  private GetAttr attr;
  private GetNode gNode;
  private GetState see;
  private NodeIdList idList;
  private NodeIdList checkList;
  private NodeIdList spareList;
  private NodeIdList waitList;
  private NodeIdList nameList;
  private NodeIdList condList;
  private int count;
  private Node newState_comp;
  private Node guide;

  public BackWardSlice(Node newFunDef) {
    attr = new GetAttr();
    gNode = new GetNode();
    see = new GetState();
    idList = new NodeIdList();
    checkList = new NodeIdList();
    spareList = new NodeIdList();
    waitList = new NodeIdList();
    nameList = new NodeIdList();
    condList = new NodeIdList();
    count = 0;
    newState_comp = newFunDef.getLastChild();

    //search for source Node of "newState_comp"
    String stateId = attr.getAttributeByNode(newState_comp, "id");
    Document owner = newFunDef.getOwnerDocument();
    NodeList nodes = owner.getElementsByTagName("statement");
    int i = 0;
    for ( ; (!(attr.getAttributeByNode(nodes.item(i), "id").equals(stateId)));
	  i++){
    }
    guide = nodes.item(i);    //current guide's position    

    //get "id" from terminals of Slice Tree
    getTerminalsId(newState_comp);
  }


  public TreeInfo backWard(Node sliceNode){    
    //check "Def" or "Use" then insert sliceNode in waitList
    if (!(see.isDef(sliceNode))){
      copyState_opt(sliceNode);
      waitList = new NodeIdList();
      waitList.insertLast(sliceNode);      
      nameList.diffNameFirst(sliceNode);
      condCheck(condList, sliceNode);
    }
    else {
      nameList.diffNameFirst(sliceNode);
      copyState_opt(sliceNode);
    }    
    dependence();

//System.out.print("cond ");
//condList.displayList();

    conditionNodes();

    TreeInfo tree = new TreeInfo();
    tree.newState_comp = newState_comp;
    tree.identList = nameList;
    tree.leftIdList = idList;
    return tree;
  }
  
  //search for necessary state_opt then make copy and join it to Slice Tree
  public void dependence(){
    if (!(waitList.isEmpty())){
      //get necessary Nodes 
      getCheckList(waitList.peek().nData);
      flowAnalyze(waitList.deleteFirst());

      checkList = spareList;
      spareList = new NodeIdList();        //initialize "spareList"

//System.out.print("check ");
//checkList.displayList();

      //copy source of "state_opt" then append it
      while (!(checkList.isEmpty())){
	copyState_opt(checkList.deleteFirst().nData);
      }
      checkList = new NodeIdList();        //initialize "checkList"
    }      
    if (!(waitList.isEmpty())){
      dependence();
    }
  }
  
  public void conditionNodes(){
    if (!(condList.isEmpty())){
      String theTail = condList.tail().sData;
      waitList = new NodeIdList();        //initialize "waitList"
      //copy "condList" to "waitList"
      for (NodeIdLink link = condList.peek();
	   link != null;
	   link = link.next){
	waitList.insertLast(link.nData);
	nameList.diffNameFirst(link.nData);
      }  
      dependence();
      if (!(theTail.equals(condList.tail().sData))){
	conditionNodes();
      }      
    }  
  }

  public void getTerminalsId(Node node){
    if (node.getNodeType() == Node.ELEMENT_NODE){
      if (attr.getAttributeByNode(node, "rhs").equals("expression_opt")){
	idList.insertFirst(node);
      }
    }
    for (Node child = node.getFirstChild();
	 child != null;
	 child = child.getNextSibling()){
      getTerminalsId(child);
    }
  }
 

  public void getCheckList(Node criterion){
    //Node criterion is current slice criterion
    //get first "checkList" then collect same name of "identifier" Node
    String theIdent = criterion.getFirstChild().getNodeValue().trim();
    String theId = attr.getAttributeByNode(criterion, "id");
    checkList = gNode.getNodeList(theIdent, guide);

    while (!(checkList.isEmpty())){
      if (checkList.peek().sData.equals(theId) ||
	  !(see.isCondNode(checkList.peek().nData))){
	spareList.insertLast(checkList.deleteFirst().nData);
      }
      else {
	checkList.deleteFirst();
      }
    }
    checkList = spareList;
    spareList = new NodeIdList();      //initialize "spareList"

    //pick up "define instruction"
    while (!(checkList.isEmpty())){
      NodeIdLink link = checkList.deleteFirst();

      //except Node describing same instruction then insert in NodeIdList 
      if (see.isDef(link.nData) || see.isStdinNode(link.nData)){
	if (gNode.getExp_opt(criterion) != null){
	  String optId = 
	    attr.getAttributeByNode(gNode.getExp_opt(link.nData), "id");
	  String sliOpt =
	    attr.getAttributeByNode(gNode.getExp_opt(criterion), "id");
	  if (!(optId.equals(sliOpt) && (!(link.sData.equals(theId))))){
	    spareList.insertLast(link.nData);	  
	  }
	}
	else {
	  spareList.insertLast(link.nData);
	}
      }
      else if (theId.equals(link.sData)){
	spareList.insertLast(link.nData);
      }
    }
    checkList = spareList;
    spareList = new NodeIdList();        //initialize "spareList"
  }

  public void copyState_opt(Node node){
    if (gNode.getExp_opt(node) != null){
      //search for target "statement" with "expression_opt" 
      Node state_opt = gNode.getExp_opt(node).cloneNode(true);
      
      //check "id" then join "state_opt"
      String opt_id = attr.getAttributeByNode(gNode.getExp_opt(node), "id");
      if (idList.find(opt_id)){
	Node joinNode = idList.delete(opt_id).nData;
	joinNode.getParentNode().replaceChild(state_opt, joinNode);
	getUseIns(state_opt);     //insert next slice criterion in "waitList"
	count = 0;                //initialize "count"
      }
    }
  }

  public void getUseIns(Node root){
    if (root.getNodeName().equals("identifier")){
      count = count + 1;
    }
    if (root.getNodeName().equals("identifier") && count > 1){
      waitList.insertLast(root);
      nameList.diffNameFirst(root);
    }
    for (Node child = root.getFirstChild();
	 child != null;
	 child = child.getNextSibling()){
      getUseIns(child);
    }
  }

  public void flowAnalyze(NodeIdLink current){
    String theId = see.stateAttr(current.nData).stId;
    NodeIdLink prev = checkList.referByLink(current).previous;
    if (see.stateAttr(current.nData).stRhs.equals("expression_opt")){
      flowExp_opt(current, theId, prev);
    }
    else if (see.stateAttr(current.nData).stRhs.equals("if")){
      flowIf(current, theId);
    }
    else if (see.stateAttr(current.nData).stRhs.equals("if-else")){
      flowIfElse(current, theId, prev);
    }
    else if (see.stateAttr(current.nData).stRhs.equals("while")){
      flowWhile(current, theId, prev);
    }
  }

  public void flowExp_opt(NodeIdLink current, String theId, NodeIdLink prev){
    if (prev != null){
      String stateId = see.stateAttr(prev.nData).stId;
      setupList(prev);
      if (see.stateAttr(prev.nData).stRhs.equals("expression_opt")){
      }
      else if (see.stateAttr(prev.nData).stRhs.equals("if")){
	for (NodeIdLink prev2 = prev.previous;
	     prev2 != null;
	     prev2 = prev2.previous){
	  if (!(see.stateAttr(prev2.nData).stId.equals(stateId)) &&
	      !(see.isNest(stateId, see.stateAttr(prev2.nData)))){
	    setupNextFlow(prev2);
	    break;
	  }
	}
      }
      else if (see.stateAttr(prev.nData).stRhs.equals("if-else")){
	if (!(see.isElse2(prev.nData, stateId))){
	  for (NodeIdLink prev2 = prev.previous;
	       prev2 != null;
	       prev2 = prev2.previous){
	    if (!(see.stateAttr(prev2.nData).stId.equals(stateId)) &&
		!(see.isNest(stateId, see.stateAttr(prev2.nData)))){
	      setupNextFlow(prev2);
	      break;
	    }
	  }
	}
	else {
	  for (NodeIdLink prev2 = prev.previous;
	       prev2 != null;
	       prev2 = prev2.previous){
	    if (!(see.stateAttr(prev2.nData).stId.equals(stateId)) &&
		!(see.isNest(stateId, see.stateAttr(prev2.nData)))){
	      setupNextFlow(prev2);
	      break;
	    }
	  }
	  for (NodeIdLink prev2 = prev.previous;
	       prev2 != null;
	       prev2 = prev2.previous){
	    if ((see.stateAttr(prev2.nData).stId.equals(stateId) &&
		 !(see.isElse2(prev2.nData, stateId)))){
	      setupList(prev2);
	      break;
	    }
	    if ((see.isNest(stateId, see.stateAttr(prev2.nData))) &&
		!(see.isElse2(prev2.nData, stateId))){
	      setupNextFlow(prev2);
	      break;
	    }
	  }
	}
      }
      else if (see.stateAttr(prev.nData).stRhs.equals("while")){
	if (see.stateAttr(prev.nData).stId.equals(theId)){
	}
	else {
	  for (NodeIdLink prev2 = prev.previous;
	       prev2 != null;
	       prev2 = prev2.previous){
	    if (!(see.stateAttr(prev2.nData).stId.equals(stateId)) &&
		!(see.isNest(stateId, see.stateAttr(prev2.nData)))){
	      setupNextFlow(prev2);
	      break;
	    }
	  }
	  for (NodeIdLink prev2 = prev.previous;
	       prev2 != null;
	       prev2 = prev2.previous){
	    if (see.stateAttr(prev2.nData).stId.equals(stateId)){
	      setupList(prev2);
	      break;
	    }
	    if (see.isNest(stateId, see.stateAttr(prev2.nData))){
	      setupNextFlow(prev2);
	      break;
	    }
	  }
	}
      }  
    }
  }

  public void flowIf(NodeIdLink current, String theId){
    NodeIdLink prev = checkList.referByLink(current).previous;
    NestInfo info = getStInfo(current, theId);
    for (NodeIdLink prev2 = prev;
	 prev2 != null;
	 prev2 = prev2.previous){
      if (see.stateAttr(prev2.nData).stId.equals(theId)){
	setupList(prev2);
	break;
      }
      if (!(see.stateAttr(prev2.nData).stId.equals(theId)) &&
	  !(see.isNest(theId, see.stateAttr(prev2.nData)))){
	if ((!info.parentId.equals(theId)) && 
	    info.nextRhs.equals("if-else")){
	    flowIfElse(current, info.nextId, prev2);
	    break;   //
	}
	else if (!info.parentId.equals(theId) && 
		 info.nextRhs.equals("while")){
	  flowWhile(current, info.nextId, prev2);
	  break;   //
	}
	else {
	  setupNextFlow(prev2);
	  break;     
	}
      }
      if (!(see.stateAttr(prev2.nData).stId.equals(theId)) &&
	  (see.isNest(theId, see.stateAttr(prev2.nData)))){
	setupNextFlow(prev2);
	if (!info.parentId.equals(theId)){
	  StateInfo tailInfo = see.stateAttr(spareList.tail().nData);
	  if (tailInfo.stId.equals(theId) || see.isNest(theId, tailInfo)){
	    break;
	  }
	  else if (info.nextRhs.equals("if-else")){
	    spareList.deleteFirst();
	    flowIfElse(current, info.nextId, prev2);	  
	    break;     //
	  }
	  else if (info.nextRhs.equals("while")){
	    spareList.deleteFirst();
	    flowWhile(current, info.nextId, prev2);
	    break;   //
	  }
	  else {
	    break;
	  }
	}
	else {
	  break;
	}
      }
    }
  }
  
  public void flowIfElse(NodeIdLink current, String theId, NodeIdLink prev){
    NestInfo info = getStInfo(current, theId);
    if (see.isElse2(current.nData, theId)){
      for (NodeIdLink prev2 = prev;
	   prev2 != null;
	   prev2 = prev2.previous){
	if (see.stateAttr(prev2.nData).stId.equals(theId)){
	  if (see.isElse2(prev2.nData, theId)){
	    setupList(prev2);
	    break;
	  }
	  else {
	    flowIfElse(current, theId, prev2.previous);
	    break; //
	  }
	}
	if (!(see.stateAttr(prev2.nData).stId.equals(theId)) &&
	    !(see.isNest(theId, see.stateAttr(prev2.nData)))){
	  if (!info.parentId.equals(theId) && 
	      info.nextRhs.equals("if-else")){
	    flowIfElse(current, info.nextId, prev2);
	    break; //
	  }
	  else if (!info.parentId.equals(theId) && 
		   info.nextRhs.equals("while")){
	    NodeIdLink nextLink = toWhileLink(theId, prev2, guide);
	    flowWhile(current, info.nextId, nextLink);
	    break;  //
	  }
	  else {
	    setupNextFlow(prev2);    
	    break;
	  }
	}
	if (!(see.stateAttr(prev2.nData).stId.equals(theId)) &&
	    (see.isNest(theId, see.stateAttr(prev2.nData))) &&
	    (see.isElse2(prev2.nData, theId))){
	  setupNextFlow(prev2);	  
	  if (!info.parentId.equals(theId)){
	    StateInfo tailInfo = see.stateAttr(spareList.tail().nData);
	    if (tailInfo.stId.equals(theId) || see.isNest(theId, tailInfo)){
	      break;
	    }
	    else if (info.nextRhs.equals("if-else")){
	      spareList.deleteFirst();
	      flowIfElse(current, info.nextId, prev2);	  
	      break;     //
	    }
	    else if (info.nextRhs.equals("while")){
	      spareList.deleteFirst();
	      NodeIdLink nextLink = toWhileLink(theId, prev2, guide);
	      flowWhile(current, info.nextId, nextLink);
	      break;     //
	    }
	    else {
	      break;
	    }
	  }
	  else {
	    break;
	  }
	}
	else {
	  flowIfElse(current, theId, prev2.previous);
	  break;  //
	}
      }	
    }
    else {
      flowIf(current, theId);
    }
  }	
  
  public void flowWhile(NodeIdLink current, String theId, NodeIdLink mark){
    NodeIdList whileList = new NodeIdList();
    NodeIdLink prev = mark;    
    NodeIdLink follow;     
    int count = 0; 
    if (mark != null){
      NestInfo info = getStInfo(current, theId);
      for (NodeIdLink prev2 = prev;
	   prev2 != null;
	   prev2 = prev2.previous){
	if (see.stateAttr(prev2.nData).stId.equals(theId)){
	  setupList(prev2);
	  count = 1;
	  break;
	}
	
	if (!(see.stateAttr(prev2.nData).stId.equals(theId)) &&
	    !(see.isNest(theId, see.stateAttr(prev2.nData)))){
	  if (!info.parentId.equals(theId) && 
	      info.nextRhs.equals("if-else")){
	    flowIfElse(current, info.nextId, prev2);
	    break;  //
	  }
	  else if (!info.parentId.equals(theId) && 
		   info.nextRhs.equals("while")){
	    flowWhile(current, info.nextId, prev2);
	    break;   //
	  }
	  else {
	    setupNextFlow(prev2);
	    break;
	  }
	}
	if (!(see.stateAttr(prev2.nData).stId.equals(theId)) &&
	    see.isNest(theId, see.stateAttr(prev2.nData))){
	  setupNextFlow(prev2);
	  StateInfo tailInfo = see.stateAttr(spareList.tail().nData);
	  if (!info.parentId.equals(theId)){
	    if (tailInfo.stId.equals(theId) || see.isNest(theId, tailInfo)){
	      count = 1;
	      break;
	    }
	    else if (info.nextRhs.equals("if-else")){
	      spareList.deleteFirst();
	      flowWhile(current, info.nextId, prev2);	  
	      break;   //
	    }
	    else if (info.nextRhs.equals("while")){
	      spareList.deleteFirst();
	      flowIfElse(current, info.nextId, prev2);
	      break;   //
	    }
	    else {
	      count = 1;
	      break;
	    }
	  }
	  else {
	    if (tailInfo.stId.equals(theId) || see.isNest(theId, tailInfo)){
	      count = 1;
	      break;
	    }
	    else {
	    break;
	    }
	  }
	}
      }
      follow = checkList.referByLink(mark).next;
      }    
    else {
      follow = checkList.referByLink(current).next;
    }
    
    if (count == 0){
      for (NodeIdLink follow2 = follow;
	   follow2 != null;
	   follow2 = follow2.next){
	if (see.stateAttr(follow2.nData).stId.equals(theId) ||
	    see.isNest(theId, see.stateAttr(follow2.nData))){
	  if (!(follow2.sData.equals(current.sData))){
	    whileList.insertLast(follow2.nData);
	  }
	}
      }
      whileList.insertLast(current.nData);
      flowExp_opt(whileList.tail(), theId, whileList.tail().previous);  
                          //While state is look like flowExp_opt
//System.out.print("while ");
//whileList.displayList();

    }
  }

  public NodeIdLink outThenNode(NodeIdLink prev2, String theId){
    for (NodeIdLink prev3 = prev2;
	 prev3 != null;
	 prev3 = prev3.previous){
      if (!(see.isElse2(prev3.nData, theId))){
	return prev3;
      }
    }    
    return null;
  }

  public NodeIdLink toWhileLink(String theId, NodeIdLink prev2, Node guide){
    Node stateNode = gNode.getNodeById(theId, guide);
    if (gNode.searchNode(prev2.sData, stateNode)){
      return outThenNode(prev2, theId);
    }
    else {
      return prev2;
    }
  }

  public void flowAnalyze2(NodeIdLink current){
    if (checkList.referByLink(current) != null){
      NodeIdLink prev = checkList.referByLink(current).previous;
      NodeIdLink follow = checkList.referByLink(current).next;
      String theId = see.stateAttr(current.nData).stId;
      if (see.stateAttr(current.nData).stRhs.equals("if") ||
	  see.stateAttr(current.nData).stRhs.equals("while")){      
	for (NodeIdLink prev2 = prev;
	     prev2 != null;
	     prev2 = prev2.previous){
	  if (!(see.stateAttr(prev2.nData).stId.equals(theId)) &&
	      !(see.isNest(theId, see.stateAttr(prev2.nData)))){
	    setupList(prev2);
	    break;
	  }
	}
      }
      else if (see.stateAttr(current.nData).stRhs.equals("if-else")){
	if (see.isElse2(current.nData, theId)){
	  for (NodeIdLink prev2 = prev;
	       prev2 != null;
	       prev2 = prev2.previous){
	    if ((see.stateAttr(prev2.nData).stId.equals(theId) &&
		 !(see.isElse2(prev2.nData, theId)))){
	      setupList(prev2);
	      break;
	    }
	    else if ((see.isNest(theId, see.stateAttr(prev2.nData))) &&
		     !(see.isElse2(prev2.nData, theId))){
	      setupNextFlow(prev2);
	      break;
	    }
	    else if (!(see.stateAttr(prev2.nData).stId.equals(theId)) &&
		     !(see.isNest(theId, see.stateAttr(prev2.nData)))){
	      setupList(prev2);
	      break;
	    }
	  }
	}
	else {
	  for (NodeIdLink prev2 = prev;
	       prev2 != null;
	       prev2 = prev2.previous){
	    if (!(see.stateAttr(prev2.nData).stId.equals(theId)) &&
		!(see.isNest(theId, see.stateAttr(prev2.nData)))){
	      setupList(prev2);
	      break;
	    }
	  }
	}
      }
    }
  }


  public void setupNextFlow(NodeIdLink link){
    spareList.insertLast(link.nData);	  
    flowAnalyze2(link);  
    condCheck(condList, link.nData);
  }
  
  public void setupList(NodeIdLink link){
    spareList.insertLast(link.nData);	  
    condCheck(condList, link.nData);
  }    

  public void condCheck(NodeIdList list, Node node){
    NodeIdList theList = new NodeIdList();
    theList = gNode.getCondNodes(node);
    while(!(theList.isEmpty())){
      list.diffNodeTail(theList.deleteFirst());
    }
  }


  public NestInfo getStInfo(NodeIdLink current, String theId){
    NestInfo neInf = new NestInfo();
    neInf.parentId = new String();
    for (StateInfo stInfo = see.stateAttr(current.nData); 
	 !stInfo.stId.equals(""); 
	 stInfo = stInfo.parentAttr){
      neInf.parentId = stInfo.stId;
    } 
    neInf.nextId = new String();
    neInf.nextRhs = new String();
    if (!(neInf.parentId.equals(theId))){
      StateInfo stInfo = see.stateAttr(current.nData);
      for (; !(stInfo.stId.equals(theId)); stInfo = stInfo.parentAttr){
      } 
      neInf.nextId =  stInfo.parentAttr.stId;
      neInf.nextRhs = stInfo.parentAttr.stRhs;
    }
    return neInf;
  }

}

class NestInfo{
  public String parentId;
  public String nextId;
  public String nextRhs;
}
