import org.w3c.dom.Node;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

class CreateSliceTree {
  private Node guide;
  public CreateSliceTree() {}

  public void sliceTree(Node sliceNode, String iName, 
			String bool_f, String bool_b){
    Document owner = sliceNode.getOwnerDocument();
    Element root = owner.getDocumentElement();
    GetAttr attr = new GetAttr(sliceNode);
    String idNo = attr.getAttributeByNode(sliceNode, "id");
    String fName = attr.getAttributeByNode(sliceNode, "filename");
    String lNo = attr.getAttributeByNode(sliceNode, "lineno");

    //create ELEMENT "slice"
    Element elemSlice = owner.createElement("slice");
    elemSlice.setAttribute("ident", iName);
    elemSlice.setAttribute("forward", bool_f);
    elemSlice.setAttribute("backward", bool_f);
    elemSlice.setAttribute("id", idNo);
    elemSlice.setAttribute("filename", fName);
    elemSlice.setAttribute("lineno", lNo);
    root.appendChild(elemSlice);

    Node newNode = root.getLastChild();  //get Node "slice"

    //search for "function_definiton"  then make the copy and append
    for (guide = sliceNode.getParentNode();
	 (!(guide.getNodeName().equals("function_definition")));
	 guide = guide.getParentNode()) {
    }
    Node funDef = guide.cloneNode(false);    
    Node newFunDef = newNode.appendChild(funDef);

    //deep copy "declaration_specifiers", "declarator" and "declaration"
    //copy "statement" with "compound" 
    NodeList children = guide.getChildNodes();
    int size = children.getLength();
    for (int i = 0; i < size; i++) {
      Node child = children.item(i);
      if (child.getNodeType() == Node.ELEMENT_NODE){
	if (child.getNodeName().equals("statement")){
	  //copy "statement" with "compound" 
	  Node state_comp = child.cloneNode(false);
	  newFunDef.appendChild(state_comp);
	}
	else {
	  Node newChild = child.cloneNode(true);
	  newFunDef.appendChild(newChild);
	}
      }
    }
    Node newState_comp = newFunDef.getLastChild();    

    //search for "declaration" then make copy
    if (guide.getLastChild().getNodeType() == Node.ELEMENT_NODE){
      guide = guide.getLastChild();
    }
    else {
      guide = guide.getLastChild().getPreviousSibling();
    }
    for (Node child = guide.getFirstChild();
	 child != null;
	 child = child.getNextSibling()){
      if (child.getNodeType() == Node.ELEMENT_NODE){
	if (child.getNodeName().equals("declaration")){
	  Node newChild = child.cloneNode(true);
	  newState_comp.appendChild(newChild);
	}
      }  
    }   //current guide's position is the first "statement" with "compound"
  
    //search for "statement" with "return" then make the copy
    for (Node child = guide.getFirstChild();
	 child != null;
	 child = child.getNextSibling()){
      if (child.getNodeName().equals("statement")){
	  Node newChild = child.cloneNode(true);
	  newState_comp.appendChild(newChild);
      }
    }

    //cut unnecessary "expression" under "newState_comp"
    setSubtree(newState_comp);
    //    cutExpression(newState_comp);

  }

  public boolean findFileIO(Node root){
    GetAttr attr = new GetAttr(root);
    Node child = root.getFirstChild();      
    if (attr.getAttributeByNode(root, "rhs").equals("expression_opt")){
      if (child.getNodeName().equals("#text")){
	child = child.getNextSibling();
      }
      if (attr.getAttributeByNode(child, "rhs").equals("funcall")){
	child = child.getFirstChild();
	if (child.getNodeName().equals("#text")){
	  child = child.getNextSibling();
	}
	child = child.getFirstChild();
	if (child.getNodeName().equals("#text")){
	  child = child.getNextSibling();
	}
	if (child.getFirstChild().getNodeValue().trim().equals("fopen") ||
	    child.getFirstChild().getNodeValue().trim().equals("fclose")){
	  return true;
	}
      }
    }
    return false;
  }

  public void setSubtree(Node node) { 
    GetAttr attr = new GetAttr(node);
    for (Node child = node.getFirstChild();
	 child != null;
	 child = child.getNextSibling()){
      if (child.getNodeName().equals("statement")){
	if (attr.getAttributeByNode(child, "rhs").equals("if") ||
	    attr.getAttributeByNode(child, "rhs").equals("if-else") ||
	    attr.getAttributeByNode(child, "rhs").equals("while") ||
	    attr.getAttributeByNode(child, "rhs").equals("compound")) {
	  setSubtree(child);
	}
	else if (attr.getAttributeByNode(child, "rhs").equals("return")){
	}
	else if (findFileIO(child)){
	}
	else {
	  cutExpression(child);
	}
      }
    }
  }

  public void cutExpression(Node node){
    for (Node child = node.getFirstChild();
	 child != null;
	 child = child.getNextSibling()){
      if (child.getNodeName().equals("expression")){
	node.removeChild(child);
      }
    }
    for (Node child = node.getFirstChild();
	 child != null;
	 child = child.getNextSibling()){
      cutExpression(child);
    }
  }
  
}
