import org.w3c.dom.Node;
import org.w3c.dom.Element;
import org.w3c.dom.Attr;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Document;
import org.w3c.dom.NodeList;

class GetNode extends GetAttr{
  private NodeIdList idList;
  private NodeIdList pickList;
  private NodeIdList condList;
  private NodeIdList seekList;

  public GetNode() {
    idList = new NodeIdList();
    pickList = new NodeIdList();
    condList = new NodeIdList();
    seekList = new NodeIdList();
  }
  
  //$BFCDj$NMWAG$r<h=P$9(B with Attrs and index
  public Node getNodeByAttrs(Document doc, String no, String name, int index){
    NodeList nodes_i = doc.getElementsByTagName("identifier");
    int size_i = nodes_i.getLength();
    
    //insert  necessary "identifier" in NodeIDList
    for (int i = 0; i < size_i; i++){
      Node identNode = nodes_i.item(i);
      Node child = identNode.getFirstChild();
      String line = getAttributeByNode(identNode, "lineno");
      String ident = child.getNodeValue().trim();
      if (line.equals(no)  && ident.equals(name)){
	idList.insertLast(identNode);
      }
    }
    
    if (idList.isEmpty()){
      System.out.println("Mismatching!");
      System.exit(1);
    }
    else {
      for (int i = 1; i < index; i++){
	idList.deleteFirst();
      }
    }
    return (idList.deleteFirst().nData);
  }


  //under "statement"
  public NodeIdList getNodeList(String identName, Node root){
    for (Node child = root.getFirstChild();
	 child != null;
	 child = child.getNextSibling()){
      if (child.getNodeName().equals("statement")){
	findExpression(identName, child);
      }
    }
    return pickList;
  }

  //under "declaration"
  public NodeIdList getDeclList(String identName, Node root){
    for (Node child = root.getFirstChild();
	 child != null;
	 child = child.getNextSibling()){
      if (child.getNodeName().equals("declaration")){
	findExpression(identName, child);
      }
    }
    return pickList;
  }

  public void findExpression(String identName, Node root){
    if (root.getNodeName().equals("identifier")){
      if (root.getFirstChild().getNodeValue().trim().equals(identName)){
	pickList.insertLast(root);
      }
    }
    for (Node child = root.getFirstChild();
	 child != null;
	 child = child.getNextSibling()){
      findExpression(identName, child);
    }
  }


  public NodeIdList getCondNodes(Node node){
    GetAttr attr = new GetAttr(node);
    for (Node parent = node.getParentNode();
	 (!(parent.getNodeName().equals("function_definition")));
	 parent = parent.getParentNode()){
      if (attr.getAttributeByNode(parent, "rhs").equals("if") ||
	  attr.getAttributeByNode(parent, "rhs").equals("if-else") ||
	  attr.getAttributeByNode(parent, "rhs").equals("while")){
	Node child = parent.getFirstChild();
	if (!(child.getNodeName().equals("expression"))){
	     child = child.getNextSibling();
	}
	if (child.getNodeName().equals("expression")){
	  getIdentNodes(child);
	}
      }
    }
    return condList;
  }

  public void getIdentNodes(Node root){
    if (root.getNodeType() == Node.ELEMENT_NODE){
      if (root.getNodeName().equals("identifier")){
	condList.insertFirst(root);
      }
      for (Node child = root.getFirstChild();
	   child != null;
	   child = child.getNextSibling()){
	getIdentNodes(child);
      }
    }
  }

  //get upside "statement" with "expression_opt"
  public Node getExp_opt(Node node){
    GetAttr attr = new GetAttr(node);
    for (node = node.getParentNode();
	 (!(node.getNodeName().equals("function_definition")));
	 node = node.getParentNode()){
      if (attr.getAttributeByNode(node, "rhs").equals("expression_opt")){
	return node;
      }
    }
    return null;
  }

  public Node getNodeById(String id, Node root){
    IdMatching(id, root);
    if (!(seekList.isEmpty())){
      return seekList.deleteFirst().nData;
    }
    else {
      return null;
    }
  }

  public boolean searchNode(String id, Node root){
    IdMatching(id, root);
    if (!(seekList.isEmpty())){
      seekList.deleteFirst();
      return true;
    }
    else {
      return false;
    }
  }

  public void IdMatching(String id, Node root){
    GetAttr attr = new GetAttr(root);
    for (Node child = root.getFirstChild();
	 child != null;
	 child = child.getNextSibling()){
      if (child.getNodeType() == Node.ELEMENT_NODE){
	if (attr.getAttributeByNode(child, "id").equals(id)){
	  seekList.insertFirst(child);
	  break;
	}
      }
      IdMatching(id, child);
    }
  }

  
}
      
