import org.w3c.dom.Node;
class StateInfo{
  public String stRhs;
  public String stId;
  public boolean elsePart;
  public StateInfo parentAttr;

  public StateInfo(){
    stRhs = new String();
    stId = new String();
    elsePart = false;
    parentAttr = null;
  }
}

class GetState {
  private GetNode gNode;
  private int matching;
  public GetState() {
    gNode = new GetNode();
    matching = 0;
  }

  //check  which of "if", "if-else", "while" and "expression_opt"
  public StateInfo stateAttr(Node node){
    GetAttr attr = new GetAttr(node);
    StateInfo stInf = new StateInfo();
    for (Node parent = node.getParentNode();
	 (!(parent.getNodeName().equals("function_definition")));
	 parent = parent.getParentNode()){
      String theRhs = attr.getAttributeByNode(parent, "rhs");
      if (theRhs.equals("if")){
	stInf.stRhs = theRhs;
	stInf.stId = attr.getAttributeByNode(parent, "id");
	stInf.parentAttr = stateAttr(parent);
	return stInf;
      }
      else if (theRhs.equals("if-else")){
	stInf.stRhs = theRhs;
	stInf.stId = attr.getAttributeByNode(parent, "id");
	stInf.elsePart = isElse(node);
	stInf.parentAttr = stateAttr(parent);
	return stInf;
      }
      else if (theRhs.equals("while")){
	stInf.stRhs = theRhs;
	stInf.stId = attr.getAttributeByNode(parent, "id");
	stInf.parentAttr = stateAttr(parent);
	return stInf;
      }
    }   
    stInf.stRhs = "expression_opt";
    return stInf;
  }

  //When the Node is "else", return true
  public boolean isElse(Node node){
    GetAttr attr = new GetAttr(node);
    String elseId = new String();
    for (node = node.getParentNode();
	 (!(attr.getAttributeByNode(node, "rhs").equals("if-else")));
	 node = node.getParentNode()){
      if (attr.getAttributeByNode(node, "rhs").equals("expression_opt")){
	elseId = attr.getAttributeByNode(node, "id");
      }
    }
    node = node.getLastChild();
    if (node.getNodeName().equals("#text")){
      node = node.getPreviousSibling();
    }
    return gNode.searchNode(elseId, node);
  }
  
  public boolean isElse2(Node node, String stateId){
    GetAttr attr = new GetAttr(node);
    String elseId = attr.getAttributeByNode(node, "id");

    for (; (!(attr.getAttributeByNode(node, "id").equals(stateId)));
	 node = node.getParentNode()){
    }
    node = node.getLastChild();
    if (node.getNodeName().equals("#text")){
      node = node.getPreviousSibling();
    }
    return gNode.searchNode(elseId, node);
  }

  //If node is nest of id, return true
  public boolean isNest(String id, StateInfo info){
    for (StateInfo parent = info.parentAttr;
	 parent != null;
	 parent = parent.parentAttr){
      if (parent.stId.equals(id)){
	return true;
      }
    }
    return false;
  }

  //When the Node is "Def", return true.
  public boolean isDef(Node node){
    GetAttr attr = new GetAttr();
    String theId = attr.getAttributeByNode(node.getParentNode(), "id");
    for (Node parent = node.getParentNode();
	 (!(attr.getAttributeByNode(parent, "rhs").equals("expression_opt")));
	 parent = parent.getParentNode()){
      if (parent.getNodeName().equals("function_definition")){
	return false;
      }
      if (attr.getAttributeByNode(parent, "rhs").equals("assign_eq") ||
	  attr.getAttributeByNode(parent, "rhs").equals("assign_mult") ||
	  attr.getAttributeByNode(parent, "rhs").equals("assign_div") ||
	  attr.getAttributeByNode(parent, "rhs").equals("assign_mod") ||
	  attr.getAttributeByNode(parent, "rhs").equals("assign_add") ||
	  attr.getAttributeByNode(parent, "rhs").equals("assign_sub") ||
	  attr.getAttributeByNode(parent, "rhs").equals("assign_lshift") ||
	  attr.getAttributeByNode(parent, "rhs").equals("assign_rshift") ||
	  attr.getAttributeByNode(parent, "rhs").equals("assign_band") ||
	  attr.getAttributeByNode(parent, "rhs").equals("assign_beor") ||
	  attr.getAttributeByNode(parent, "rhs").equals("assign_bior")){
	Node child = parent.getFirstChild();
	if (child.getNodeName().equals("#text")){
	  child = child.getNextSibling();
	}
	if (child.getNodeName().equals("expression")){
	  String opId = attr.getAttributeByNode(child, "id");
	  if (opId.equals(theId)){
	    return true;
	  }
	  else {
	    return false;
	  }
	}
      }
    }
    return false;
  }

  //when "stdin", return true
  public boolean isStdinNode(Node node){
    GetAttr attr = new GetAttr(node);
    for (Node parent = node.getParentNode();
	 (!(parent.getNodeName().equals("function_definition")));
	 parent = parent.getParentNode()){
      if (attr.getAttributeByNode(parent, "rhs").equals("funcall")){
	Node child = parent.getFirstChild();
	if (child.getNodeName().equals("#text")){
	  child = child.getNextSibling();
	}
	if (attr.getAttributeByNode(child, "rhs").equals("identifier")){
	  Node ident = child.getFirstChild();
	  if (ident.getNodeName().equals("#text")){
	    ident = ident.getNextSibling();
	  }	  
	  if (ident.getFirstChild().getNodeValue().trim().equals("getchar") ||
	      ident.getFirstChild().getNodeValue().trim().equals("putchar") ||
	      ident.getFirstChild().getNodeValue().trim().equals("scanf") ||
	      ident.getFirstChild().getNodeValue().trim().equals("sscanf") ||
	      ident.getFirstChild().getNodeValue().trim().equals("fopen") ||
	      ident.getFirstChild().getNodeValue().trim().equals("getc") ||
	      ident.getFirstChild().getNodeValue().trim().equals("putc") ||
	      ident.getFirstChild().getNodeValue().trim().equals("puts") ||
	      ident.getFirstChild().getNodeValue().trim().equals("ungetc") ||
	      ident.getFirstChild().getNodeValue().trim().equals("fscanf") ||
	      ident.getFirstChild().getNodeValue().trim().equals("fprintf") ||
	      ident.getFirstChild().getNodeValue().trim().equals("fgets") ||
	      ident.getFirstChild().getNodeValue().trim().equals("fputs") ||
	      ident.getFirstChild().getNodeValue().trim().equals("getline")){
	    return true;
	  }
	}
      }
    }
    return false;
  }

    //When "condition Node", return true 
  public boolean isCondNode(Node node){
    GetAttr attr = new GetAttr(node);
    for (Node parent = node.getParentNode();
	 (!(parent.getNodeName().equals("function_definition")));
	 parent = parent.getParentNode()){
      if (attr.getAttributeByNode(parent, "rhs").equals("equal") ||
	  attr.getAttributeByNode(parent, "rhs").equals("not-equal") ||
	  attr.getAttributeByNode(parent, "rhs").equals("less") ||
	  attr.getAttributeByNode(parent, "rhs").equals("more") ||
	  attr.getAttributeByNode(parent, "rhs").equals("less-equal") ||
	  attr.getAttributeByNode(parent, "rhs").equals("more-equal")){
	return true;
      }
    }
    return false;
  }

}

