import org.w3c.dom.Node;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

class TrimBranch extends DeepRemoveChildren{
  private GetAttr attr;
  private GetState see;
  private GetNode gNode;
  private NodeIdList idList;
  private NodeIdList cutList;
  private NodeIdList pickList;

  public TrimBranch(){
    attr = new GetAttr();
    see = new GetState();
    gNode = new GetNode();
    idList = new NodeIdList();
    cutList = new NodeIdList();
    pickList = new NodeIdList();
  }

  public void trimBranch(TreeInfo info){
    int count = countId(info.identList);
    /**
    if (count == 0){
      System.out.println("No Reduction!");
    }
    else if (count == 1){
      System.out.println("Reduced 1 instruction");
    }
    else {
      System.out.println("Reduced "+count+" instructions");
    }
    */

    for (int a = 0; a <= count; a++){
      cleanTree(info.newState_comp);
    }
    
//System.out.println(idList.isEmpty());    

    NodeIdList list = listupName(info.newState_comp, info.identList);
    uselessName(info.newState_comp, list);

  }

  public int countId(NodeIdList list){
    int count = 0;
    for (NodeIdLink link = list.peek();
	 link != null;
	 link = link.next){
      idList.insertFirst(link.nData);
      count = count + 1;
    }  
    return count;
  }

  public void cleanTree(Node info){
    //deep cut unnecessary "statement"
    caseCompound(info);
  }
    
  public void caseExp_opt(Node opt){
    Node child = opt.getFirstChild();
    if (opt.getNodeType() == Node.ELEMENT_NODE){
      if (child.getNodeName().equals("#text")){
	if ((child.getNextSibling() == null) || 
	    (child.getNextSibling().getNodeName().equals("#text"))){
	  idList.delete(attr.getAttributeByNode(opt, "id"));
	  removeAllChildren(opt);
	  opt.getParentNode().removeChild(opt);
	}
      }
    }
  }

  public int stateCounter(Node node){
    int count = 0;
    if (attr.getAttributeByNode(node, "rhs").equals("expression_opt")){
      for (Node state = node.getFirstChild();
	   state != null;
	   state = state.getNextSibling()){	
	if (state.getNodeType() == Node.ELEMENT_NODE){
	  count = count + 1;
	}
      }      
    }
    else { 
      for (Node state = node.getFirstChild();
	   state != null;
	   state = state.getNextSibling()){
	if (state.getNodeName().equals("statement")){
	  count = count + 1;
	}
      }
    }
    return count;
  }
  
  public void deleteState(Node node){
    if (node.getParentNode() != null){
      deepCut(node);
      node.getParentNode().removeChild(node);
    }    
  }

  public void getReady(Node node){
    for (Node state = node.getFirstChild();
	 state != null;
	 state = state.getNextSibling()){
      if (state.getNodeName().equals("statement")){
	assignState(state);
      }
    }
  }

  public void assignState(Node state){
    if (state.getNodeType() == Node.ELEMENT_NODE){
      if (attr.getAttributeByNode(state, "rhs").equals("if") ||
	  attr.getAttributeByNode(state, "rhs").equals("while")){
	caseIf_While(state);
      }
      else if (attr.getAttributeByNode(state, "rhs").equals("if-else")){
	caseIfElse(state);
      }
      else {
	whichExpComp(state);
      }
    }
  }

  public void caseIf_While(Node ifWhile){
    if (ifWhile.getNodeType() == Node.ELEMENT_NODE){
      getReady(ifWhile);
      int countState = stateCounter(ifWhile);
      if (countState == 0){
	deleteState(ifWhile);
      }
    }
  }

  public void caseIfElse(Node ifElse){
    if (ifElse.getNodeType() == Node.ELEMENT_NODE){
      Node state = ifElse.getFirstChild();
      for (; state != null;
	   state = state.getNextSibling()){
	if (state.getNodeName().equals("statement")){
	  break;
	}
      }
      Node elseState = ifElse.getLastChild();
      for (; elseState != null;
	   elseState = elseState.getPreviousSibling()){
	if (elseState.getNodeName().equals("statement")){
	  break;
	}
      }      
      int countIfElse = stateCounter(ifElse);
      if (countIfElse == 0){
	deleteState(ifElse);
      }
      else if (countIfElse == 1){
	assignState(state);
	int countS = stateCounter(state);
	if (countS == 0){
	  deleteState(ifElse);
	  /**
	  deleteState(state);
	  replaceIfElse(ifElse);	 
	  */
	}
	else {
	  if (see.stateAttr(state).elsePart){
	    for (Node exp = state.getPreviousSibling();
		 exp != null;
		 exp = exp.getPreviousSibling()){
	      if (exp.getNodeName().equals("expression")){
		replaceCondition(exp);
		break;
	      }
	    }
	    replaceIfElse(ifElse);
	  }
	  else {
	    replaceIfElse(ifElse);
	  }
	}
      }     
      else {
	assignState(state);
	int countT = stateCounter(state);
	if (countT == 0){
	  deleteState(state);
	  assignState(elseState);
	  int countE = stateCounter(elseState);
	  if (countE == 0){
	    deleteState(ifElse);	  
	  }
	  else {
	    for (Node exp = elseState.getPreviousSibling();
		 exp != null;
		 exp = exp.getPreviousSibling()){
	      if (exp.getNodeName().equals("expression")){
		replaceCondition(exp);
		break;
	      }
	    }
	    replaceIfElse(ifElse);
	  }	
	}
	else {
	  assignState(elseState);
	  int countE = stateCounter(elseState);
	  if (countE == 0){
	    deleteState(elseState);
	    replaceIfElse(ifElse);
	  }
	}
      }
    }
  }
      
  public void whichExpComp(Node state){
    if (state.getNodeType() == Node.ELEMENT_NODE){
      if (attr.getAttributeByNode(state, "rhs").equals("expression_opt")){
	caseExp_opt(state);
      }
      else if (attr.getAttributeByNode(state, "rhs").equals("compound")){
	caseCompound(state);
      }
    }
  }

  public void caseCompound(Node root){
    getReady(root);
    int count = stateCounter(root);
    if (count == 0){
      deleteState(root);
    }
    else if (count == 1){
      Node temp = root.getFirstChild().cloneNode(true);
      deepCut(root);
      for (Node child = temp.getFirstChild();
	   child != null;
	   child = child.getNextSibling()){
	root.getParentNode().appendChild(child);
      }
      root.getParentNode().removeChild(root);
    }
  }
  
  public Node makeIfElse(Node ifElse){
    Document doc = ifElse.getOwnerDocument();
    String id = attr.getAttributeByNode(ifElse, "id");
    String filename = attr.getAttributeByNode(ifElse, "filename");
    String lineno = attr.getAttributeByNode(ifElse, "lineno");    

    Element ifNode = doc.createElement("statement");
    ifNode.setAttribute("rhs", "if");
    ifNode.setAttribute("id", id);
    ifNode.setAttribute("filename", filename);
    ifNode.setAttribute("lineno", lineno);

    for (Node child = ifElse.getFirstChild();
	 child != null;
	 child = child.getNextSibling()){
      ifNode.appendChild(child.cloneNode(true));
    }
    return ifNode;
  }

  public Node makeCondition(Node exp){
    Document doc = exp.getOwnerDocument();
    String id = attr.getAttributeByNode(exp, "id");
    String filename = attr.getAttributeByNode(exp, "filename");
    String lineno = attr.getAttributeByNode(exp, "lineno");    

    Element negNode = doc.createElement("expression");
    negNode.setAttribute("rhs", "unary-neg");
    negNode.setAttribute("type_ref", "xxxxxx");
    negNode.setAttribute("id", id);
    negNode.setAttribute("filename", filename);
    negNode.setAttribute("lineno", lineno);

    Element parenNode = doc.createElement("expression");
    parenNode.setAttribute("rhs", "paren");
    parenNode.setAttribute("type_ref", "xxxxxx");
    parenNode.setAttribute("id", id);
    parenNode.setAttribute("filename", filename);
    parenNode.setAttribute("lineno", lineno);
    
    parenNode.appendChild(exp.cloneNode(true));
    negNode.appendChild(parenNode);
    return negNode;
  }

  public void replaceIfElse(Node ifElse){
    Node newIfNode = makeIfElse(ifElse);
    ifElse.getParentNode().insertBefore(newIfNode, ifElse);
    deleteState(ifElse);
  }

  public void replaceCondition(Node exp){
    Node newExpNode = makeCondition(exp);
    exp.getParentNode().insertBefore(newExpNode, exp);
    deleteState(exp);
  }

  public void cutName(Node root, String ident){
    NodeIdList nameList = new NodeIdList(); 
    nameList = gNode.getDeclList(ident, root);
    Node name = nameList.deleteFirst().nData;
    for ( ; (!(name.getNodeName().equals("declaration")));
	 name = name.getParentNode()){
      if (name.getParentNode().getNodeName().equals("declaration")){
	break;
      }
    }
    Node parent = name.getParentNode();
    deleteState(name);

    int count = 0;
    for (Node child = parent.getFirstChild();
	 child != null;
	 child = child.getNextSibling()){
      if (child.getNodeType() == Node.ELEMENT_NODE){
	count = count + 1;
      }	
    }
    if (count == 1){
      deleteState(parent);
    }
  }
  
  public NodeIdList listupName(Node root, NodeIdList list){
    for (Node dec = root.getFirstChild();
	 dec != null;
	 dec = dec.getNextSibling()){
      if (dec.getNodeName().equals("declaration")){
	getIdentNodes(dec);
      }
    }

    while (!(list.isEmpty())){
      String key = list.peek().ident;
      if (cutList.seekName(key)){
	cutList.deleteName(list.deleteFirst().ident);
      }
      else {
	list.deleteFirst();
      }
    }
    return cutList;
  }

  public void getIdentNodes(Node root){
    if (root.getNodeType() == Node.ELEMENT_NODE){
      if (root.getNodeName().equals("identifier")){
	cutList.insertFirst(root);
      }
      for (Node child = root.getFirstChild();
	   child != null;
	   child = child.getNextSibling()){
	getIdentNodes(child);
      }
    }
  }

  public void uselessName(Node root, NodeIdList list){
    while (!(list.isEmpty())){
      cutName(root, list.deleteFirst().ident);
    }
  }

}
