import java.io.PrintWriter;
import org.w3c.dom.Node;

class AbsDecl {
  private int count;

  public AbsDecl(Node node, PrintWriter writer){
  count = 1;
  }

  public void absDecl(Node node, PrintWriter writer){
    GetAttr thisAttr = new GetAttr(node);
    String thisRhs = thisAttr.getAttributeByNode(node, "rhs");
    for (Node child = node.getFirstChild();
	 child != null;
	 child = child.getNextSibling()){
      forAbsDecl(child, writer);
    }
    if (count != 1 && thisRhs.equals("func_pair")){
      writer.print(")");
      count = 1;
    }
  }

  public void forAbsDecl(Node node, PrintWriter writer){
    switch(node.getNodeType()){
    case Node.TEXT_NODE:
    case Node.ELEMENT_NODE:
      String elemName = node.getNodeName();
      
      if (elemName.equals("pointer")) {
	Pointer pointer = new Pointer(node, writer);
	pointer.pointer(node, writer);
      }

      else if (elemName.equals("parameter_declaration")){
	GetAttr attr = new GetAttr(node.getParentNode());
	String rhs = attr.getAttributeByNode(node.getParentNode(), "rhs");
	ParaDecl paraDecl = new ParaDecl(node, writer);
	if (rhs.equals("func_pair")){
	  if (count == 1){
	    writer.print("(");
	    paraDecl.paraDecl(node, writer);
	    count = count + 1;
	  }
	  else {
	    writer.print(", ");
	    paraDecl.paraDecl(node, writer);
	  }
	}
	else {
	  paraDecl.paraDecl(node, writer);
	}
      }

      else if (elemName.equals("expression")){
	Expression expr = new Expression(node, writer);
	expr.express(node, writer);
      }

      else if (elemName.equals("ellipsis")){
	writer.println("...");
      }

      else if (elemName.equals("abstract_declarator")){
	GetAttr attr = new GetAttr(node.getParentNode());
	String rhs = attr.getAttributeByNode(node.getParentNode(), "rhs");
	
	if (rhs.equals("paren")){
	  writer.print("(");
	  absDecl(node, writer);
	  writer.print(")");
	}
	else {
	  absDecl(node, writer);
	}
      }
      break;
    default:
      writer.println("Error in AbsDecl");
      System.exit(1);
      break;
    }
  }
}
