import java.io.PrintWriter;
import org.w3c.dom.Node;

class DeclSpe {
  public DeclSpe(Node node, PrintWriter writer){}

  public void declSpe(Node node, PrintWriter writer) {
   switch(node.getNodeType()){
    case Node.TEXT_NODE:
    case Node.ELEMENT_NODE:
      Node child = node.getFirstChild();
      String elemName = node.getNodeName();

      if (
	  //storage_class_specifier       
	  elemName.equals("auto") ||
	  elemName.equals("register") ||
	  elemName.equals("static") ||
	  elemName.equals("extern") ||
	  elemName.equals("typedef") ||
	  elemName.equals("") ||
	  
	  //type_qualifier
	  elemName.equals("const") ||
	  elemName.equals("volatile") ||
	  
	  //type_specifier 
	  //except struct_or_union_specifier, enum_specifier and typedef_name
	  
	  elemName.equals("void") ||
	  elemName.equals("char") ||
	  elemName.equals("short") ||
	  elemName.equals("int") ||
	  elemName.equals("long") ||
	  elemName.equals("float") ||
	  elemName.equals("double") ||
	  elemName.equals("signed") ||
	  elemName.equals("unsigned")) {
	
	writer.print(elemName+" ");
      }
      else if (elemName.equals("struct_or_union_specifier")){
	GetAttr thisAttr = new GetAttr(node);
	String thisRhs = thisAttr.getAttributeByNode(node, "rhs");

	writer.print(thisRhs+" ");
	StructUnion strUni = new StructUnion(node, writer);
	strUni.strUni(node, writer);
      }

      else if (elemName.equals("enum_specifier")){
	writer.print("enum ");
	EnumSpe enumSpe = new EnumSpe(node, writer);
	enumSpe.enumSpe(node, writer);
      }

      else if (elemName.equals("typedef_name")){
	writer.print(child.getNodeValue().trim()+" ");
      }
      break;
    default:
      writer.println("Error in DeclSpe");
      System.exit(1);
      break;
    }
  }
}
