import java.io.PrintWriter;
import org.w3c.dom.Node;

class Declaration {
  private int count;   //for "declaration" to insert "," 

  public Declaration(Node node, PrintWriter writer){
    count = 1;
  }

  public void declaration(Node node, PrintWriter writer){
    for (Node child = node.getFirstChild();
	 child != null;
	 child = child.getNextSibling()){
      forDeclaration(child, writer);
    }
    count = 1;
  }

  public void forDeclaration(Node node, PrintWriter writer){
    switch(node.getNodeType()){
    case Node.TEXT_NODE:
    case Node.ELEMENT_NODE:
      String elemName = node.getNodeName();
      
      if (elemName.equals("declarator")){
	if (count == 1) {
	  count = count + 1;
	  Declarator declarator = new Declarator(node, writer);
	  declarator.declarator(node, writer);
	}
	else {
	  writer.print(", ");
	  Declarator declarator = new Declarator(node, writer);
	  declarator.declarator(node, writer);
	}
      }
      else if (elemName.equals("initializer")){
	writer.print("= ");
	Initializer initial = new Initializer(node, writer);
	initial.initializer(node, writer);
      } 
      else {
	DeclSpe declSpe = new DeclSpe(node, writer);
	declSpe.declSpe(node, writer);
    }
      break;
    default:
      writer.println("Error in Declaration");
      System.exit(1);
      break;
    }
  }
}
