import java.io.PrintWriter;
import org.w3c.dom.Node;


class Declarator {
  private int count_a;   //for "array" to select [...] or [] 
  private int count_p;   //for "parameter_declaration" to insert ","
  private int count_o;   //for "func_old" to insert ","

  public Declarator(Node node, PrintWriter writer){
    count_a = 1;
    count_p = 1;
    count_o = 1;
  }

  public void declarator(Node node, PrintWriter writer){
    GetAttr thisAttr = new GetAttr(node);
    String thisRhs = thisAttr.getAttributeByNode(node, "rhs");

    for (Node child = node.getFirstChild();
	 child != null;
	 child = child.getNextSibling()){
      forDeclarator(child, writer);
    }
    if (count_a == 2 && thisRhs.equals("array")){
      writer.print("[]");
      count_a = 1;
    }
    if (count_p != 1 && 
	(thisRhs.equals("func_new") || 
	 thisRhs.equals("func_old"))){
      writer.println(") ");
    }
    if (count_o != 1 && (thisRhs.equals("func_old"))){
      writer.println(") ");
      count_o = 1;
    }
  }

  public void forDeclarator(Node node, PrintWriter writer){
    switch(node.getNodeType()){
    case Node.TEXT_NODE:
    case Node.ELEMENT_NODE:
      Node child = node.getFirstChild();
      String elemName = node.getNodeName();

      GetAttr attr = new GetAttr(node.getParentNode());
      String rhs = attr.getAttributeByNode(node.getParentNode(), "rhs");
      GetAttr attr_g = new GetAttr(node.getParentNode().getParentNode());
      String rhs_g = 
	attr_g.getAttributeByNode(node.getParentNode().getParentNode(), "rhs");

      if (elemName.equals("identifier")){
	if (rhs.equals("func_old")){
	  if (count_o == 2){
	    writer.print(child.getNodeValue().trim());
	    count_o = count_o + 1;
	  }
	  else if (count_o == 3){
	    writer.print(", "+child.getNodeValue().trim());
	  }
	}
	else if (rhs_g.equals("array")){
	  writer.print(child.getNodeValue().trim());
	  count_a = 2;
	}
	else {
	  writer.print(child.getNodeValue().trim());
	  if (rhs_g.equals("func_old")){
	    writer.print("(");
	    count_o = count_o + 1;
	  }
	}
      }
      
      else if (elemName.equals("declarator")){
	if (rhs.equals("paren")){
	  writer.print("(");
	  declarator(node, writer);
	  writer.print(")");
	}
	else {
	  declarator(node, writer);
	}
      } 

      else if (elemName.equals("pointer")){
	Pointer pointer = new Pointer(node, writer);
	pointer.pointer(node, writer);
      } 

      else if (elemName.equals("parameter_declaration")){
	ParaDecl paraDecl = new ParaDecl(node, writer);	
	if (count_p == 1) {
	  writer.print("(");
	  paraDecl.paraDecl(node, writer);
		  count_p = count_p + 1;
	}
	else {
	  writer.print(", ");
	  paraDecl.paraDecl(node, writer);
	} 
      }

      else if (elemName.equals("expression")){
	Expression expr = new Expression(node, writer);
	if (rhs.equals("array")){
	  writer.print("[");
	  expr.express(node, writer);
	  writer.print("]");
	  count_a = 1;
	}
	else {
	  writer.println("Error exp in Declarator: rhs="+rhs);
	  expr.express(node, writer);
	}
      } 

      else if (elemName.equals("ellipsis")){
	writer.print(" ...");
      }
      break;
    default:
      writer.println("Error in Declarator");
      System.exit(1);
      break;      
    }
  }
}
