import java.io.PrintWriter;
import org.w3c.dom.Node;

class EnumSpe {
  private int count;      //to insert "," 

  public EnumSpe(Node node, PrintWriter writer) {
    count = 1;
  }

  public void enumSpe(Node node, PrintWriter writer){
    GetAttr thisAttr = new GetAttr(node);
    String thisRhs = thisAttr.getAttributeByNode(node, "rhs");
    for (Node child = node.getFirstChild();
	 child != null;
	 child = child.getNextSibling()){
      forEnumSpe(child, writer);
    }
    if (!(thisRhs.equals("nobody"))) {
      writer.print("}");
    }
    count = 1;
  }

  public void forEnumSpe(Node node, PrintWriter writer){
    switch(node.getNodeType()){
    case Node.TEXT_NODE:
    case Node.ELEMENT_NODE: 
      Node child = node.getFirstChild();
      String elemName = node.getNodeName();
      GetAttr attr = new GetAttr(node.getParentNode());
      String rhs = attr.getAttributeByNode(node.getParentNode(), "rhs");

      if (elemName.equals("identifier")){
	if (count == 1) {
	  if (rhs.equals("notag")){
	    writer.print("{"+child.getNodeValue().trim());	
	    count = count + 1;
	  }
	  else {
	    writer.print(child.getNodeValue().trim()+" ");
	    count = count + 1;
	  }
	}
	else if (count == 2) {
	  if (rhs.equals("notag")) {
	    writer.print(", "+child.getNodeValue().trim());
	    count = count + 1;
	  }
	  else {
	    writer.print("{"+child.getNodeValue().trim());	
	    count = count + 1;
	  }
	}
	else {
	  writer.print(", "+child.getNodeValue().trim());
	}
      }

      else if (elemName.equals("expression")){
	Expression expr = new Expression(node, writer);
	  expr.express(node, writer);
	  }
    default:
      writer.println("Error in EnumSpe");
      System.exit(1);
      break;
    }
  }
}
