import java.io.PrintWriter;
import org.w3c.dom.Node;

class Expression {
  LinkList count_c;      // for "conditional operator"
  private int count_f;   // for "function call"
  private int count_a;   // for "array"
  private int count_o;   // for other operator
  private int tmp_f;     // for "function call"

  public Expression(Node node, PrintWriter writer){
    count_c = new LinkList();
    count_f = 1;
    count_a = 1;
    count_o = 1;
    tmp_f = 0;
  }

  public void express(Node node, PrintWriter writer){    
    GetAttr thisAttr = new GetAttr(node);
    String thisRhs = thisAttr.getAttributeByNode(node, "rhs");

    for (Node child = node.getFirstChild();
	 child != null;
	 child = child.getNextSibling()){
      forExpress(child, writer);
    }


    if (thisRhs.equals("funcall")){
      if (count_f == 2) {
	writer.print("() ");
	count_f = 1;
      }
      else {
      writer.print(")");    //for funcall 
      count_f = 1;
      }
    }


  }

  public void forExpress(Node node, PrintWriter writer){    
    switch(node.getNodeType()){
    case Node.TEXT_NODE:
    case Node.ELEMENT_NODE:
      Node child = node.getFirstChild();    
      String elemName = node.getNodeName();

      if (elemName.equals("identifier")){
	writer.print(child.getNodeValue().trim());
      }

      else if (elemName.equals("constant")){
	GetAttr thisAttr = new GetAttr(node);
	String thisRhs = thisAttr.getAttributeByNode(node, "rhs");
	toChar ascii = new toChar();

	if (node.getChildNodes().getLength() == 1){
	  if (thisRhs.equals("char")){
	    String num = child.getNodeValue();
	    String code = ascii.toASCII(num);
	    writer.print(code);
	  }
	  else {
	    writer.print(child.getNodeValue().trim());
	  }
	}
	else {
	 writer.print("\""+child.getNextSibling().getNodeValue().trim()+"\""); 
	}
      }

      else if (elemName.equals("expression")){
	  GetAttr attr = new GetAttr(node.getParentNode());
	  String rhs = attr.getAttributeByNode(node.getParentNode(), "rhs");
	  GetAttr thisAttr = new GetAttr(node);
	  String thisRhs = thisAttr.getAttributeByNode(node, "rhs");

//function call expression

	if (rhs.equals("funcall")){
	  if (count_f == 1) {
	    express(node, writer);
	    count_f = count_f + 1;
	  }
	  else if (count_f == 2){
	    if (thisRhs.equals("funcall")){
	      tmp_f = count_f;
	      count_f = 1;
	      writer.print("(");       
	      express(node, writer);
	      count_f = tmp_f + 1;
	      tmp_f = 0;
	    }
	    else {
	      writer.print("(");    
	      express(node, writer);
	      count_f = count_f + 1;
	    }
	  }
	  else {
	    if (thisRhs.equals("funcall")){
	      tmp_f = count_f;
	      count_f = 1;
	      writer.print(", ");
	      express(node, writer);
	      count_f = tmp_f + 1;
	      tmp_f = 0;
	    }
	    else {
	      writer.print(", ");
	      express(node, writer);
	    }
	  }
	}

	

//comma operator
	else if (rhs.equals("comma")){
	  if (count_o ==1) {
	    express(node, writer);
	    count_o = count_o + 1;
	  }
	  else {
	    writer.print(", ");
	    count_o = 1;
	    express(node, writer);
	  }
	}

//assigment operators
	else if (rhs.equals("assign_eq")){
	  if (count_o == 1) {
	    express(node, writer);
	    count_o = count_o + 1;
	  }
	  else {
	    writer.print(" = ");
	    count_o = 1;
	    express(node, writer);
	  }
	}

	else if (rhs.equals("assign_mult")){
	  if (count_o == 1) {
	    express(node, writer);
	    count_o = count_o + 1;
	  }
	  else {
	    writer.print(" *= ");
	    count_o = 1;
	    express(node, writer);
	  }
	}

	else if (rhs.equals("assign_div")){
	  if (count_o == 1) {
	    express(node, writer);
	    count_o = count_o + 1;
	  }
	  else {
	    writer.print(" /= ");
	    count_o = 1;
	    express(node, writer);
	  }
	}

	else if (rhs.equals("assign_mod")){
	  if (count_o == 1) {
	    express(node, writer);
	    count_o = count_o + 1;
	  }
	  else {
	    writer.print(" %= ");
	    count_o = 1;
	    express(node, writer);
	  }
	}

	else if (rhs.equals("assign_add")){
	  if (count_o == 1) {
	    express(node, writer);
	    count_o = count_o + 1;
	  }
	  else {
	    writer.print(" += ");
	    count_o = 1;
	    express(node, writer);
	  }
	}

	else if (rhs.equals("assign_sub")){
	  if (count_o == 1) {
	    express(node, writer);
	    count_o = count_o + 1;
	  }
	  else {
	    writer.print(" -= ");
	    count_o = 1;
	    express(node, writer);
	  }
	}

	else if (rhs.equals("assign_lshift")){
	  if (count_o == 1) {
	    express(node, writer);
	    count_o = count_o + 1;
	  }
	  else {
	    writer.print(" <<= ");
	    count_o = 1;
	    express(node, writer);
	  }
	}

	else if (rhs.equals("assign_rshift")){
	  if (count_o == 1) {
	    express(node, writer);
	    count_o = count_o + 1;
	  }
	  else {
	    writer.print(" >>= ");
	    count_o = 1;
	    express(node, writer);
	  }
	}

	else if (rhs.equals("assign_band")){
	  if (count_o == 1) {
	    express(node, writer);
	    count_o = count_o + 1;
	  }
	  else {
	    writer.print(" &= ");
	    count_o = 1;
	    express(node, writer);
	  }
	}

	else if (rhs.equals("assign_beor")){
	  if (count_o == 1) {
	    express(node, writer);
	    count_o = count_o + 1;
	  }
	  else {
	    writer.print(" ^= ");
	    count_o = 1;
	    express(node, writer);
	  }
	}

	else if (rhs.equals("assign_bior")){
	  if (count_o == 1) {
	    express(node, writer);
	    count_o = count_o + 1;
	  }
	  else {
	    writer.print(" |= ");
	    count_o = 1;
	    express(node, writer);
	  }
	}


//conditional operator
	else if (rhs.equals("conditional")){
	  if (count_c.isEmpty() || thisRhs.equals("conditional")){
	    count_c.insertFirst(1);
	  }

	  if (count_c.peek() == 1) {
	    count_c.deleteFirst();
	    express(node, writer);
	    count_c.insertFirst(2);
	  }
	  else if (count_c.peek() == 2) {
	    writer.print(" ? ");
	    count_c.deleteFirst();
	    express(node, writer);
	    count_c.insertFirst(3);
	  }
	  else {
	    writer.print(" : ");
	    count_c.deleteFirst();
	    express(node, writer);
	    count_c.insertFirst(2);   
	  }
	}

//logical operators
	else if (rhs.equals("logical-or")){
	  if (count_o == 1) {
	    express(node, writer);
	    count_o = count_o + 1;
	  }
	  else {
	    writer.print(" || ");
	    count_o = 1;
	    express(node, writer);
	  }
	}

	else if (rhs.equals("logical-and")){
	  if (count_o == 1) {
	    express(node, writer);
	    count_o = count_o + 1;
	  }
	  else {
	    writer.print(" && ");
	    count_o = 1;
	    express(node, writer);
	  }
	}

//bitwise opratiors
	else if (rhs.equals("bitwise-inclusive-or")){
	  if (count_o == 1) {
	    express(node, writer);
	    count_o = count_o + 1;
	  }
	  else {
	    writer.print(" | ");
	    count_o = 1;
	    express(node, writer);
	  }
	}

	else if (rhs.equals("bitwise-exclusive-or")){
	  if (count_o == 1) {
	    express(node, writer);
	    count_o = count_o + 1;
	  }
	  else {
	    writer.print(" ^ ");
	    count_o = 1;
	    express(node, writer);
	  }
	}

	else if (rhs.equals("bitwise-and")){
	  if (count_o == 1) {
	    express(node, writer);
	    count_o = count_o + 1;
	  }
	  else {
	    writer.print(" & ");
	    count_o = 1;
	    express(node, writer);
	  }
	}

//equality operators
	else if (rhs.equals("equal")){
	  if (count_o == 1) {
	    express(node, writer);
	    count_o = count_o + 1;
	  }
	  else {
	    writer.print(" == ");
	    count_o = 1;
	    express(node, writer);
	  }
	}

	else if (rhs.equals("not-equal")){
	  if (count_o == 1) {
	    express(node, writer);
	    count_o = count_o + 1;
	  }
	  else {
	    writer.print(" != ");
	    count_o = 1;
	    express(node, writer);
	  }
	}

//relational operators
	else if (rhs.equals("less")){
	  if (count_o == 1) {
	    express(node, writer);
	    count_o = count_o + 1;
	  }
	  else {
	    writer.print(" < ");
	    count_o = 1;
	    express(node, writer);
	  }
	}

	else if (rhs.equals("more")){
	  if (count_o == 1) {
	    express(node, writer);
	    count_o = count_o + 1;
	  }
	  else {
	    writer.print(" > ");
	    count_o = 1;
	    express(node, writer);
	  }
	}

	else if (rhs.equals("less-equal")){
	  if (count_o == 1) {
	    express(node, writer);
	    count_o = count_o + 1;
	  }
	  else {
	    writer.print(" <= ");
	    count_o = 1;
	    express(node, writer);
	  }
	}

	else if (rhs.equals("more-equal")){
	  if (count_o == 1) {
	    express(node, writer);
	    count_o = count_o + 1;
	  }
	  else {
	    writer.print(" >= ");
	    count_o = 1;
	    express(node, writer);
	  }
	}

//bitwise shift operator
	else if (rhs.equals("left-shift")){
	  if (count_o == 1) {
	    express(node, writer);
	    count_o = count_o + 1;
	  }
	  else {
	    writer.print(" << ");
	    count_o = 1;
	    express(node, writer);
	  }
	}

	else if (rhs.equals("right-shift")){
	  if (count_o == 1) {
	    express(node, writer);
	    count_o = count_o + 1;
	  }
	  else {
	    writer.print(" >> ");
	    count_o = 1;
	    express(node, writer);
	  }
	}


//binary operators
	else if (rhs.equals("add")){
	  if (count_o == 1) {
	    express(node, writer);
	    count_o = count_o + 1;
	  }
	  else {
	    writer.print(" + ");
	    count_o = 1;
	    express(node, writer);
	  }
	}

	else if (rhs.equals("sub")){
	  if (count_o == 1) {
	    express(node, writer);
	    count_o = count_o + 1;
	  }
	  else {
	    writer.print(" - ");
	    count_o = 1;
	    express(node, writer);
	  }
	}

	else if (rhs.equals("mult")){
	  if (count_o == 1) {
	    express(node, writer);
	    count_o = count_o + 1;
	  }
	  else {
	    writer.print(" * ");
	    count_o = 1;
	    express(node, writer);
	  }
	}

	else if (rhs.equals("div")){
	  if (count_o == 1) {
	    express(node, writer);
	    count_o = count_o + 1;
	  }
	  else {
	    writer.print(" / ");
	    count_o = 1;
	    express(node, writer);
	  }
	}

	else if (rhs.equals("mod")){
	  if (count_o == 1) {
	    express(node, writer);
	    count_o = count_o + 1;
	  }
	  else {
	    writer.print(" % ");
	    count_o = 1;
	    express(node, writer);
	  }
	}


//cast operator
	else if (rhs.equals("cast")){
	  express(node, writer);
	}

//prefixed operators
	else if (rhs.equals("pre-increment")){
	  writer.print("++");
	  express(node, writer);
	}

	else if (rhs.equals("pre-decrement")){
	  writer.print("--");
	  express(node, writer);
	}

//unary operators
	else if (rhs.equals("unary-address")){
	  writer.print("&");
	  express(node, writer);
	}

	else if (rhs.equals("unary-deref")){
	  writer.print("*");
	  express(node, writer);
	}

	else if (rhs.equals("unary-add")){
	  writer.print("+");
	  express(node, writer);
	}

	else if (rhs.equals("unary-sub")){
	  writer.print("-");
	  express(node, writer);
	}

	else if (rhs.equals("unary-comp")){
	  writer.print("~");
	  express(node, writer);
	}

	else if (rhs.equals("unary-neg")){
	  writer.print("!");
	  express(node, writer);
	}

//sizeof operator
	else if (rhs.equals("sizeof-exp")){
	  writer.print("sizeof");
	  express(node, writer);
	}

//dot operator
	else if (rhs.equals("dot")){
	  express(node, writer);
	  writer.print(".");
	}

//arrow operator
	else if (rhs.equals("arrow")){
	  express(node, writer);
	  writer.print("->");
	}

//posted operators
	else if (rhs.equals("post-increment")){
	  express(node, writer);
	  writer.print("++ ");
	}

	else if (rhs.equals("post-decrement")){
	  express(node, writer);
	  writer.print("-- ");
	}

//in case of "array"
	else if (rhs.equals("array")){
	  if (count_a == 1){
	    express(node, writer);
	    count_a = count_a + 1;
	  }
	  else {
	  writer.print("[");
	  express(node, writer);
	  writer.print("]");
	  count_a = 1;
	  }
	}

//in case of "paren"
	else if (rhs.equals("paren")){
	  writer.print("(");
	  express(node, writer);
	  writer.print(")");
	}

	else {
	  writer.println("Error exp in Expression: rhs="+rhs);
	  express(node, writer);	  
	}
      }

      else if (elemName.equals("type_name")){
	GetAttr attr = new GetAttr(node.getParentNode());
	String rhs = attr.getAttributeByNode(node.getParentNode(), "rhs");

	if (rhs.equals("sizeof-type")){
	  writer.print("sizeof");
	    }
	writer.print("(");
	TypeName typeName = new TypeName(node, writer);
	typeName.typeName(node, writer);
	writer.print(")");
      }
      break;

    default:
      writer.println("Error in Expression");
      System.exit(1);
      break;
    }
  }
}
