import java.io.PrintWriter;
import org.w3c.dom.Node;

class Initializer {
  private int count_l;
  private int count_e;

  public Initializer(Node node, PrintWriter writer) {
    count_l = 1;
    count_e = 1;
  }

  public void initializer(Node node, PrintWriter writer){
    GetAttr thisAttr = new GetAttr(node);
    String thisRhs = thisAttr.getAttributeByNode(node, "rhs");
    if (thisRhs.equals("list")){
      writer.print("{");
    }
    for (Node child = node.getFirstChild();
	 child != null;
	 child = child.getNextSibling()){
      forInitializer(child, writer);
    }
    if (thisRhs.equals("list")){
      writer.print("}");
      count_e = 1;
    }
    //    count_l = 1;
  }

  public void forInitializer(Node node, PrintWriter writer){
    switch(node.getNodeType()){
    case Node.TEXT_NODE:
    case Node.ELEMENT_NODE:
      String elemName = node.getNodeName();
     
      GetAttr attr = new GetAttr(node.getParentNode());
      String rhs = attr.getAttributeByNode(node.getParentNode(), "rhs");

      if (elemName.equals("expression")){
	Expression expr = new Expression(node, writer);
	if (count_e == 1){
	  expr.express(node, writer);
	  count_e = count_e + 1;
	}
	else {
	  writer.print(", ");
	  expr.express(node, writer);
	} 
      }

      else if (elemName.equals("initializer")){
	GetAttr thisAttr = new GetAttr(node);
	String thisRhs = thisAttr.getAttributeByNode(node, "rhs");

	if (rhs.equals("list") && thisRhs.equals("list")){
	  if (count_l == 1){
	    initializer(node, writer);
	    count_l = count_l + 1;
	  }
	  else {
	    writer.print(", ");
	    initializer(node, writer);
	  } 
	}
	else {
	  initializer(node, writer);
	}
      }
      break;
    default:
      writer.println("Error in Initializer");
      System.exit(1);
      break;
    }
  }
} 
