import java.io.PrintWriter;
import org.w3c.dom.Node;

class Statement {
  private int count_i;    // for "if-else"
  private int count_f;    // for "for"

  public Statement(Node node, PrintWriter writer) {
   count_i = 1; 
   count_f = 1;
  }

  public void state(Node node, PrintWriter writer){
    GetAttr thisAttr = new GetAttr(node);
    String thisRhs = thisAttr.getAttributeByNode(node, "rhs");
    if (thisRhs.equals("compound")){
      writer.println("{");
    }
    for (Node child = node.getFirstChild();
	 child != null;
	 child = child.getNextSibling()){
      forState(child, writer);
    }
    if (thisRhs.equals("compound")){
      writer.println("}");
    }
  }

  public void forState(Node node, PrintWriter writer){
    GetAttr attr = new GetAttr(node.getParentNode());
    String rhs = attr.getAttributeByNode(node.getParentNode(), "rhs");

    switch(node.getNodeType()){
    case Node.TEXT_NODE:
    case Node.ELEMENT_NODE:
      Node child = node.getFirstChild();
      String elemName = node.getNodeName();

      if (elemName.equals("identifier")){
//in case of "goto"
	if (rhs.equals("goto")){
	  writer.println("goto "+child.getNodeValue().trim()+";");
	}
//in case of "label"
	else if (rhs.equals("label")) {
	  writer.print(child.getNodeValue().trim()+":");
	}
	else {
	  writer.println("Error identifier in Statement: rhs="+rhs);
	  writer.println(child.getNodeValue());
	}
      }
      else if (elemName.equals("continue") || elemName.equals("break")){
	writer.println(elemName +";");
      }
      else if (elemName.equals("declaration")){
	Declaration decl = new Declaration(node, writer);
	decl.declaration(node, writer);
	writer.println(";");
      }
      else if (elemName.equals("symbol")){
	//	writer.print("");
      }
      else if (elemName.equals("expression")){
	count_i = 1;      // for neted "if"  initialize 'count_t
	Expression expr = new Expression(node, writer);

//in case of "case"
	if (rhs.equals("case")){
	  writer.print("case ");
	  expr.express(node, writer);
	  writer.print(": ");
	}

//in case of "if" and "if-else"
	else if (rhs.equals("if") || rhs.equals("if-else")){
	  writer.print("if (");
	  expr.express(node, writer);
	  writer.println(")");
	}

//in case of "switch"
	else if (rhs.equals("switch")){
	  writer.print("switch (");
	  expr.express(node, writer);
	  writer.println(")");
	}

//in case of "while"
	else if (rhs.equals("while")){
	  writer.print("while (");
	  expr.express(node, writer);
	  writer.print(") ");
	}

//in case of "do-while"
	else if (rhs.equals("do-while")){
	  writer.print("while (");
	  expr.express(node, writer);
	  writer.println(") ;");
	}

//in case of "for"
	else if (rhs.equals("for")){
	  if (count_f == 1){
	    writer.print("for (");
	    expr.express(node, writer);
	    writer.print("; ");
	    count_f = count_f + 1;
	  }
	  else if (count_f == 2){
	    expr.express(node, writer);
	    writer.print("; ");
	    count_f = count_f + 1;
	  }
	  else {	
	    expr.express(node, writer);
	    writer.print(") ");
	    count_f = 1;
	  }
	}

//in case of "return"
	else if (rhs.equals("return")){
	  writer.print("return ");
	  expr.express(node, writer);
	  writer.println(";");
	}

//in case of "expression_opt"
	else if (rhs.equals("expression_opt")){
	  expr.express(node, writer);
	  writer.println(";");
	}

	else {  
	  writer.println("Error exp in Statement: rhs="+rhs);
	  expr.express(node, writer);
	}
      }


      else if (elemName.equals("statement")){
//in case of "if-else"
	if (rhs.equals("if-else")){
	  if (count_i == 1) {
	    state(node, writer);
	    count_i = count_i + 1;
	  }
	  else {
	    writer.print("else ");
	    state(node, writer);
	    count_i = 1;
	  }
	}

//in case of "default"
	else if (rhs.equals("default")){
	  writer.print("default: ");
	  state(node, writer);
	}

//in case of "do-while"
	else if (rhs.equals("do-while")){
	  writer.print("do ");
	  state(node, writer);
	}

	else {
	  //	  writer.println("Error state in Statement: rhs="+rhs);
	  state(node, writer);
	}
      }

      else if (elemName.equals("empty_expression")){
	if (rhs.equals("for")){
	  if (count_f == 1){
	    writer.print("for (");
	    writer.print("; ");
	    count_f = count_f + 1;
	  }
	  else if (count_f == 2){
	    writer.print("; ");
	    count_f = count_f + 1;
	  }
	  else {	
	    writer.print(") ");
	    count_f = 1;
	  }
	}
	else if (rhs.equals("expression_opt")){
	  writer.println(";");
	}
	else {
	  writer.println("Error empty_exp in Statement: rhs="+rhs);
	  writer.println(";");
	}
      }
      break;
    default:
      writer.println("Error in Statement");
      System.exit(1);
      break;
    }
  }
}
