import org.w3c.dom.Node;
import org.w3c.dom.Element;
import org.w3c.dom.Document;
import java.io.PrintWriter;

public class Trans {
  
  public Trans() {}

  public void translation(Node node, PrintWriter writer){
    //file check
    Document owner = node.getOwnerDocument();
    Element root = owner.getDocumentElement();
    GetAttr attr = new GetAttr(node);
    String attrFilename = attr.getAttributeByElement(root, "filename");
    
    writer.println("#include <stdio.h>");
    writer.println("");
    for (Node child = node.getFirstChild();
	 child != null;
	 child = child.getNextSibling()){
      forTranslation(child, writer, attrFilename);
    }
  }
  
  public void forTranslation(Node node, PrintWriter writer,
				    String attrFilename){
    switch(node.getNodeType()){
    case Node.TEXT_NODE: 
    case Node.ELEMENT_NODE:
      String elemName = node.getNodeName();
      
      //pick "function_definition" and "declaration"
      if (elemName.equals("function_definition")){
	GetAttr attr_f = new GetAttr(node);
	String file_f = attr_f.getAttributeByNode(node, "filename");
	if (file_f.equals(attrFilename)){
	  FunDef funDef = new FunDef(node, writer);
	  funDef.funDef(node, writer);
	}
      }    
      else if (elemName.equals("declaration")){
	GetAttr attr_d = new GetAttr(node);
	String file_d = attr_d.getAttributeByNode(node, "filename");
	if (file_d.equals(attrFilename)){
	  Declaration decl = new Declaration(node, writer);
	  decl.declaration(node, writer);
	  writer.println(";");
	}
      }
      break;
    default:
      writer.println("Error in translation");
      System.exit(1);
      break;
    }
  }
}
