import org.w3c.dom.Document;
import org.w3c.dom.Node;
//import org.xml.sax.InputSource;
//import com.ibm.xml.parsers.DOMParser;
//import com.ibm.xml.parsers.ValidatingSAXParser;
//import org.apache.xerces.parsers.DOMParser;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import java.io.FileInputStream;
import java.io.PrintWriter;
import java.io.FileWriter;
import java.io.File;
 
public class Unparse {
  public static void unparse(Node node, PrintWriter writer) {
    Trans trans = new Trans();
    switch (node.getNodeType()){
    case Node.DOCUMENT_NODE:
      unparse(node.getFirstChild(), writer);
      break;

    case Node.DOCUMENT_TYPE_NODE:
      unparse(node.getNextSibling(), writer);
      break;

    case Node.ELEMENT_NODE:
      String elemName = node.getNodeName();
      if (elemName.equals("translation_unit")){
	trans.translation(node, writer);
       }
      break;

    default:
		//writer.println("Error in Unparse");
		//writer.println(node.getNodeValue());
      unparse(node.getNextSibling(), writer);     //for other parser
      break;
    }
  }
  
  public static void main(String[] args) {
    try {
	// for jaxp1.1
		DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
		//dbf.setValidating(true);       //optional
		//dbf.setIgnoringElementContentWhitespace(true);    //optional
		DocumentBuilder domp = dbf.newDocumentBuilder();
		Document doc=domp.parse(new File(args[0])); //for jaxp1.1

	// for other parseres
		//DOMParser domp = new DOMParser(); 
		//domp.parse(new InputSource(new FileInputStream(args[0]))); 
		//ValidatingSAXParser vsax = new ValidatingSAXParser();   //xml4j
		//vsax.parse(new InputSource(new FileInputStream(args[0]))); //xml4j


		if (args[0].endsWith(".xml")) {
			int end = args[0].lastIndexOf('.');
			String fileName = args[0].substring(0, end).concat("_unp.c");
			FileWriter fw = new FileWriter(fileName);
			PrintWriter pwriter = new PrintWriter(fw);

			unparse(doc.getDocumentElement(), pwriter);       // for jaxp1.1
			//unparse(domp.getDocument(), pwriter);       //for other parseres
			
			pwriter.flush();
			pwriter.close();
		}
		else {
			System.out.println
				("Please put \".xml\" at the tail of the filename");
			System.exit(1);
		}
		
    } catch (Exception e) {
		e.printStackTrace();
    }
  }
	
}

