/*
    XCI: eXperimental C Interpreter for ANSI C
    -- Copyright (c) 2000-2001, gondow@jaist.ac.jp
    $Id: attr.h,v 1.1.1.1 2002/06/06 01:41:56 gondow Exp $
*/ 

#ifndef XCI_ATTR_H
#define XCI_ATTR_H
/* ---------------------------------------------------------------------- */
enum AttrKind {
    ATTR_SWITCH_TABLE,
    ATTR_GOTO_DEST,
    ATTR_BREAK_DEST,
    ATTR_CONTINUE_DEST,
    ATTR_BLOCK_SP_OFFSET
};

struct Attribute {
    enum AttrKind    kind;
    struct Attribute *next;

    union {
	struct {
	    struct AST *ast_default;
	    struct AST **ast_case;
	    int        case_num;
	} a_sw_table;

	struct {
	    struct AST *ast_dest;
	    struct AST **ast_path;
	    int        path_num;
	} a_goto;

	struct {
	    struct AST *ast_dest;
    	} a_break_continue;

	struct {
	    int  offset;
	} a_block_sp_offset;
    } u;
};
/* ---------------------------------------------------------------------- */
struct Attribute *create_attr_sw_table (struct AST *ast_default,
					struct AST **ast_case, int case_num);
struct AST *get_break_exit      (struct AST const *ast_break);
void        set_break_exit      (struct AST *ast_break);
struct AST *get_continue_exit   (struct AST const *ast_continue);
void        set_continue_exit   (struct AST *ast_continue);
int         get_block_sp_offset (struct AST const *ast);
void        set_block_sp_offset (struct AST *ast, int offset);
struct Attribute *get_goto_dest (struct AST const *ast_goto);
void              set_goto_dest (struct AST *ast_goto);
struct Attribute *get_block_sw_table (struct AST const *ast_switch);
void              set_block_sw_table (struct AST *ast_switch,
				      struct Attribute *attr_switch);
/* ---------------------------------------------------------------------- */
#endif /* XCI_ATTR_H */
