/*
    XCI: eXperimental C Interpreter for ANSI C
    -- Copyright (c) 2000-2001, gondow@jaist.ac.jp
    $Id: typedef.h,v 1.1.1.1 2002/06/06 01:41:56 gondow Exp $
*/ 

#ifndef XCI_TYPEDEF_H
#define XCI_TYPEDEF_H

enum NameKind {
    NK_UNKNOWN,
    NK_IDENTIFIER,
    NK_TYPEDEF_NAME,
    NK_ENUMERATION_CONSTANT
};

struct TypedefName {
    char const         *name;   /* typedef name */
    enum NameKind      kind;	/* typedef_name, identifier, enum_constant */ 
    struct TypedefName *next;   /* pointer to next entry (NULL terminated ) */
};

struct TypedefTable {
    struct TypedefName **stack; /* extended dynamically with realloc */
    int                sp;      /* stack top pointer */
    int                size;    /* size of currently allocated stack */
};

/* ---------------------------------------------------------------------- */

void typedef_entry  (char const *name, enum NameKind kind, int level_adjust);
void typedef_entry_by_declarator (struct AST *ast, int is_typedef);
void typedef_entry_by_function_declarator (struct AST *ast);
void typedef_entry_by_enumerator (struct AST *ast);
void typedef_entry_by_identifier_list (struct AST *ast);
enum NameKind  typedef_kind (char const *name);
void typedef_scope_begin ();
void typedef_scope_end   ();

#endif /* XCI_TYPEDEF_H */
