/*
    XCI: eXperimental C Interpreter for ANSI C
    -- Copyright (c) 2000, gondow@jais.ac.jp
    $Id: xci.h,v 1.3 2002/07/09 11:43:46 gondow Exp $
*/ 

#ifndef XCI_XCI_H
#define XCI_XCI_H

#ifndef XCI_AST_H
#include "AST.h"
#endif

/* ---------------------------------------------------------------------- */
#define YYSTYPE struct AST *
#define YYERROR_VERBOSE
#define MAIN_NAME "main"

extern FILE     *yyin;
extern int      lineno;
extern char     *inc_filename;
extern char     *filename;
extern char     *yytext;
extern int      typedef_flag;

enum { MAX_ATEXIT_FUNC = 32 };
extern int      atexit_index;
extern void     *atexit_func [];
/* ---------------------------------------------------------------------- */
int     yyerror      (char *mesg);
#if 0
int     yyerror_args (char *mesg, ...);
#endif
void    xci_error    (struct AST const *ast, char const *mesg);
void    xci_error_args (struct AST const *ast, char const *mesg, ...);
void 	xci_error_noast (char *mesg);
void    xci_error_noast_args (char *mesg, ...);
void 	*emalloc     (int size);
void    *erealloc    (void *ptr, int size);
void    *ecalloc     (int nelem, int size);
void    efree        (void *ptr);
#endif /* XCI_XCI_H */

