/*
    XCI: Experimental C Interpreter for ANSI C
    -- Copyright (c) 2000-2002, gondow@jaist.ac.jp
    $Id: math.h,v 1.1 2002/07/09 16:13:36 gondow Exp $
*/ 

#ifndef XCI_MATH_H
#define XCI_MATH_H
#define HUGE_VAL 1.0e999

double sin   (double x);
double cos   (double x);
double tan   (double x);
double asin  (double x);
double acos  (double x);
double atan  (double x);
double atan2 (double y, double x);
double sinh  (double x);
double cosh  (double x);
double tanh  (double x);

double exp   (double x);
double log   (double x);
double log10 (double x);
double pow   (double x, double y);
double sqrt  (double x);

double ceil  (double x);
double floor (double x);
double fabs  (double x);
double frexp (double x, int *exp);
double ldexp (double x, int exp);
double modf  (double value, double *iptr);
double fmod  (double x, double y);
#endif /* XCI_MATH_H */
