/*
    XCI: Experimental C Interpreter for ANSI C
    -- Copyright (c) 2000-2002, gondow@jaist.ac.jp
    $Id: string.h,v 1.1 2002/07/09 01:31:45 gondow Exp $
*/ 

#ifndef XCI_STRING_H
#define XCI_STRING_H
#include <stdio.h> /* for size_t */
void *memcpy   (void *s1, const void *s2, size_t n);
void *memmove  (void *s1, const void *s2, size_t n);
char *strcpy   (char *s1, const char *s2);
char *strncpy  (char *s1, const char *s2, size_t n);
char *strcat   (char *s1, const char *s2);
char *strncat  (char *s1, const char *s2, size_t n);
int memcmp     (const void *s1, const void *s2, size_t n);
int strcmp     (const char *s1, const char *s2);
int strcoll    (const char *s1, const char *s2);
int strncmp    (const char *s1, const char *s2, size_t n);
size_t strxfrm (char *s1, const char *s2, size_t n);
void *memchr   (const void *s, int c, size_t n);
char *strchr   (const char *s, int c);
size_t strcspn (const char *s1, const char *s2);
char *strpbrk  (const char *s1, const char *s2);
char *strrchr  (const char *s, int c);
size_t strspn  (const char *s1, const char *s2);
char *strstr   (const char *s1, const char *s2);
char *strtok   (char *s1, const char *s2);
void *memset   (void *s, int c, size_t n);
char *strerror (int ret_arg);
size_t strlen  (const char *s);
#endif /* XCI_STRING_H */
