/*
    XCI: Experimental C Interpreter for ANSI C
    -- Copyright (c) 2000-2002, gondow@jaist.ac.jp
    $Id: time.h,v 1.1 2002/07/09 16:13:36 gondow Exp $
*/ 

#ifndef XCI_TIME_H
#define XCI_TIME_H
#include <stddef.h> /* for NULL, size_t */
#define CLOCKS_PER_SEC 1000
typedef unsigned long clock_t;
typedef long time_t;

struct tm
{
    int   tm_sec;
    int   tm_min;
    int   tm_hour;
    int   tm_mday;
    int   tm_mon;
    int   tm_year;
    int   tm_wday;
    int   tm_yday;
    int   tm_isdst;
};

clock_t   clock      (void);
time_t    time       (time_t *timer);
double    difftime   (time_t time1, time_t time0);
time_t    mktime     (struct tm *timeptr);

char      *asctime   (const struct tm *timeptr);
char      *ctime     (const time_t *timer);
struct tm *gmtime    (const time_t *timer);
struct tm *localtime (const time_t *timer);
size_t    strftime   (char *s, size_t maxsize, const char *format,
		      const struct tm *timeptr);
#endif /* XCI_TIME_H */
